{
  Var = fun label value => 
    if std.is_record value then
      value | {_: Var}
    else if std.is_string value then
      value | String
    else 
      std.contract.blame_with_message "value was not a record or string" label,
 
  Vars =
  {
    vars = {
      name
        | String,
      owner
        | String,
      values
        | {_ |  Var}
    }
  },

  Cluster = {
    name | String,
    env | {_: String} | optional
  },

  Clusters = {_: Cluster},

  DatabaseOffering = {
    database = {
      enabled 
        | Bool 
        | optional
    } 
  },

  QueueOffering = {
    rabbitmq = {
      enabled 
        | Bool 
        | optional
    } 
  },

  GoPlan = {
    go_plan = {
      clusters
        | Clusters
    }
     & DatabaseOffering 
     & QueueOffering

  }
}
